Loading...
Searching...
No Matches
juce::MidiOutput Class Referencefinal

## Detailed Description

Represents a midi output device using the old bytestream format.

To create one of these, use the static getAvailableDevices() method to find out what outputs are available, and then use the openDevice() method to try to open one.

See also
  MidiInput

The documentation for this class was generated from the following file:

- juce_audio_devices/midi_io/juce_MidiDevices.h

## Public Member Functions

MidiDeviceInfo | getDeviceInfo () const noexcept
| Returns the MidiDeviceInfo struct containing some information about this device.
String | getIdentifier () const noexcept
| Returns the identifier of this device.
String | getName () const noexcept
| Returns the name of this device.
void | setName (const String &newName) noexcept
| Sets a custom name for the device.
uint8_t | getGroup () const
| In the case that this output refers to a specific group of a UMP output, this returns the index of the group.
ump::EndpointId | getEndpointId () const
| Returns the EndpointId that uniquely identifies the UMP endpoint that contains this output.
void | sendMessageNow (const MidiMessage &message)
| Sends out a MIDI message immediately.
void | sendBlockOfMessagesNow (const MidiBuffer &buffer)
| Sends out a sequence of MIDI messages immediately.
void | sendBlockOfMessages (const MidiBuffer &buffer, double millisecondCounterToStartAt, double samplesPerSecondForBuffer)
| This lets you supply a block of messages that will be sent out at some point in the future.
void | clearAllPendingMessages ()
| Gets rid of any midi messages that had been added by sendBlockOfMessages().
void | startBackgroundThread ()
| Starts up a background thread so that the device can send blocks of data.
void | stopBackgroundThread ()
| Stops the background thread, and clears any pending midi events.
bool | isBackgroundThreadRunning () const
| Returns true if the background thread used to send blocks of data is running.

## Static Public Member Functions

static Array< MidiDeviceInfo > | getAvailableDevices ()
| Returns a list of the available midi output devices.
static MidiDeviceInfo | getDefaultDevice ()
| Returns the MidiDeviceInfo of the default midi output device to use.
static std::unique_ptr< MidiOutput > | openDevice (const String &deviceIdentifier)
| Tries to open one of the midi output devices.
static std::unique_ptr< MidiOutput > | createNewDevice (const String &deviceName)
| This will try to create a new midi output device (only available on Linux, macOS and iOS).

## Member Functions

## getAvailableDevices()

Array< MidiDeviceInfo > juce::MidiOutput::getAvailableDevices | ( |  | ) |

static

Returns a list of the available midi output devices.

You can open one of the devices by passing its identifier into the openDevice() method.

See also
  MidiDeviceInfo, getDevices, getDefaultDeviceIndex, openDevice

Referenced by getDefaultDevice().

## getDefaultDevice()

MidiDeviceInfo juce::MidiOutput::getDefaultDevice | ( |  | ) |

inline static

Returns the MidiDeviceInfo of the default midi output device to use.

References getAvailableDevices().

## openDevice()

std::unique_ptr< MidiOutput > juce::MidiOutput::openDevice | ( | const String & | deviceIdentifier | ) |

static

Tries to open one of the midi output devices.

This will return a MidiOutput object if it manages to open it, you can then send messages to this device.

If the device can't be opened, this will return an empty object.

Parameters

  deviceIdentifier | the ID of the device to open - use the getAvailableDevices() method to find the available devices that can be opened

See also
  getDevices

## createNewDevice()

std::unique_ptr< MidiOutput > juce::MidiOutput::createNewDevice | ( | const String & | deviceName | ) |

static

This will try to create a new midi output device (only available on Linux, macOS and iOS).

This will attempt to create a new midi output device with the specified name that other apps can connect to and use as their midi input.

NB - if you are calling this method on iOS you must have enabled the "Audio Background Capability" setting in the iOS exporter otherwise this method will fail.

Returns an empty object if a device can't be created.

Parameters

  deviceName | the name of the device to create

## getDeviceInfo()

MidiDeviceInfo juce::MidiOutput::getDeviceInfo | ( |  | ) | const

noexcept

Returns the MidiDeviceInfo struct containing some information about this device.

Referenced by getIdentifier(), and getName().

## getIdentifier()

String juce::MidiOutput::getIdentifier | ( |  | ) | const

inline noexcept

Returns the identifier of this device.

References getDeviceInfo(), and getIdentifier().

Referenced by getIdentifier().

## getName()

String juce::MidiOutput::getName | ( |  | ) | const

inline noexcept

Returns the name of this device.

References getDeviceInfo().

## setName()

void juce::MidiOutput::setName | ( | const String & | newName | ) |

inline noexcept

Sets a custom name for the device.

## getGroup()

uint8_t juce::MidiOutput::getGroup | ( |  | ) | const

inline

In the case that this output refers to a specific group of a UMP output, this returns the index of the group.

## getEndpointId()

ump::EndpointId juce::MidiOutput::getEndpointId | ( |  | ) | const

inline

Returns the EndpointId that uniquely identifies the UMP endpoint that contains this output.

## sendMessageNow()

void juce::MidiOutput::sendMessageNow | ( | const MidiMessage & | message | ) |

inline

Sends out a MIDI message immediately.

References juce::MidiMessage::asSpan().

Referenced by sendBlockOfMessagesNow().

## sendBlockOfMessagesNow()

void juce::MidiOutput::sendBlockOfMessagesNow | ( | const MidiBuffer & | buffer | ) |

inline

Sends out a sequence of MIDI messages immediately.

References sendMessageNow().

## sendBlockOfMessages()

void juce::MidiOutput::sendBlockOfMessages | ( | const MidiBuffer & | buffer,
|  | double | millisecondCounterToStartAt,
|  | double | samplesPerSecondForBuffer )

inline

This lets you supply a block of messages that will be sent out at some point in the future.

The MidiOutput class has an internal thread that can send out timestamped messages - this appends a set of messages to its internal buffer, ready for sending.

This will only work if you've already started the thread with startBackgroundThread().

A time is specified, at which the block of messages should be sent. This time uses the same time base as Time::getMillisecondCounter(), and must be in the future.

The samplesPerSecondForBuffer parameter indicates the number of samples per second used by the MidiBuffer. Each event in a MidiBuffer has a sample position, and the samplesPerSecondForBuffer value is needed to convert this sample position to a real time.

References jassert.

## clearAllPendingMessages()

void juce::MidiOutput::clearAllPendingMessages | ( |  | ) |

inline

Gets rid of any midi messages that had been added by sendBlockOfMessages().

## startBackgroundThread()

void juce::MidiOutput::startBackgroundThread | ( |  | ) |

inline

Starts up a background thread so that the device can send blocks of data.

Call this to get the device ready, before using sendBlockOfMessages().

## stopBackgroundThread()

void juce::MidiOutput::stopBackgroundThread | ( |  | ) |

inline

Stops the background thread, and clears any pending midi events.

See also
  startBackgroundThread

## isBackgroundThreadRunning()

bool juce::MidiOutput::isBackgroundThreadRunning | ( |  | ) | const

inline

Returns true if the background thread used to send blocks of data is running.

See also
  startBackgroundThread, stopBackgroundThread

### Purchase

Get JUCE

### Discover

What's New in JUCE Features

### Learn

Documentaion Tutorials Made with JUCE Resources

### Support

JUCE Forum Newsletter Archive

### About

Contact Us JUCE Legal JUCE Licensing FAQ

### Events

Audio Developer Conference
© Raw Material Software Limited